## basis-universal 2.0.2

=== CMakeLists.txt ===
# Important: The Basis Universal encoder and transcoder libraries must be compiled with -fno-strict-aliasing (MSVC's default, and also the Linux kernel).
# It should also work without this option, but we do not test with it.
cmake_minimum_required(VERSION 3.20)

project(basisu C CXX)

# pybind11: allow old Python finder modules without complaining
if (POLICY CMP0148)
    cmake_policy(SET CMP0148 OLD)
endif()

add_compile_definitions($<$<CONFIG:Debug>:_DEBUG=1>)

if (CMAKE_SYSTEM_NAME STREQUAL "WASI")
    set(BASISU_BUILD_WASM TRUE)
else()
    set(BASISU_BUILD_WASM FALSE)
endif()

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

option(BASISU_STATIC "static linking" FALSE)
option(BASISU_SAN "sanitize" FALSE)
option(BASISU_EXAMPLES "build examples" TRUE)
option(BASISU_WASM_THREADING "Enable WASI threading support" OFF)
option(BASISU_BUILD_PYTHON "Build native Python module via pybind11" OFF)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/bin)

# For MSVC builds default to SSE enabled, and determine if it's a 64-bit (-A x64) vs. 32-bit (-A Win32) build.
if (MSVC)
    option(BASISU_SSE "SSE 4.1 support" TRUE)
    if ( CMAKE_GENERATOR_PLATFORM STREQUAL Win32 )    
        set(BASISU_BUILD_X64 0)
    else()
        set(BASISU_BUILD_X64 1)
    endif()
    add_compile_options(/W4)
else()
    option(BASISU_SSE "SSE 4.1 support" FALSE)
    option(BASISU_BUILD_X64 "build 64-bit" TRUE)
endif()

option(BASISU_ZSTD "ZSTD support for KTX2 transcoding/encoding" TRUE)
option(BASISU_OPENCL "OpenCL support in encoder" FALSE)

# Old option to new (BASISU_ prefixed) automatic remapping
foreach(pair
    "STATIC;BASISU_STATIC"
    "SAN;BASISU_SAN"
    "EXAMPLES;BASISU_EXAMPLES"
    "WASM_THREADING;BASISU_WASM_THREADING"
    "BUILD_PYTHON;BASISU_BUILD_PYTHON"
    "BUILD_X64;BASISU_BUILD_X64"
    "SSE;BASISU_SSE"
    "ZSTD;BASISU_ZSTD"
    "OPENCL;BASISU_OPENCL"
)
    list(GET pair 0 OLD)
    list(GET pair 1 NEW)

    if(DEFINED ${OLD})
        message(WARNING "[BASISU] Legacy option '${OLD}' is deprecated. Use '${NEW}' instead.")
        set(${NEW} "${${OLD}}" CACHE BOOL "" FORCE)
    endif()
endforeach()

if (BASISU_BUILD_WASM)
    message(STATUS "Configuring for WASM (WASI-SDK)")

    # WASM is always 32-bit
    set(BASISU_BUILD_X64 OFF CACHE BOOL "" FORCE)

    # WASM cannot use SSE
    set(BASISU_SSE OFF CACHE BOOL "" FORCE)

    # WASM cannot use OpenCL
    set(BASISU_OPENCL OFF CACHE BOOL "" FORCE)

    # WASM cannot use static linking
    set(BASISU_STATIC OFF CACHE BOOL "" FORCE)

    # WASM cannot use sanitizers
    set(BASISU_SAN OFF CACHE BOOL "" FORCE)
endif()

message("Initial CMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE}")
message("Initial BASISU_BUILD_X64=${BASISU_BUILD_X64}")
message("Initial BASISU_BUILD_WASM=${BASISU_BUILD_WASM}")
message("Initial BASISU_WASM_THREADING=${BASISU_WASM_THREADING}")
message("Initial BASISU_BUILD_PYTHON=${BASISU_BUILD_PYTHON}")
message("Initial BASISU_SSE=${BASISU_SSE}")
message("Initial BASISU_ZSTD=${BASISU_ZSTD}")
message("Initial BASISU_OPENCL=${BASISU_OPENCL}")
message("Initial BASISU_SAN=${BASISU_SAN}")
message("Initial BASISU_EXAMPLES=${BASISU_EXAMPLES}")

if ((NOT MSVC) AND BASISU_OPENCL)
    # With MSVC builds we use the Khronos lib/include files in the project's "OpenCL" directory, to completely avoid requiring fiddly to install vendor SDK's.
    # Otherwise we use the system's (if any).
    find_package(OpenCL)
    message(STATUS "OpenCL found: ${OPENCL_FOUND}")
    message(STATUS "OpenCL includes: ${OpenCL_INCLUDE_DIRS}")
    message(STATUS "OpenCL libraries: ${OpenCL_LIBRARIES}")
endif()

if( NOT CMAKE_BUILD_TYPE )
  set( CMAKE_BUILD_TYPE Release )
endif()

message(${PROJECT_NAME} " build type: " ${CMAKE_BUILD_TYPE})

if (BASISU_BUILD_X64)
    message("Building 64-bit")
else()
    message("Building 32-bit")
endif()

if (BASISU_SSE)
    message("SSE enabled")
else()
    message("SSE disabled")
endif()

if (BASISU_ZSTD)
    message("Zstandard enabled")
else()
    message("Zstandard disabled")
endif()

if (NOT MSVC AND NOT BASISU_BUILD_WASM)
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -g")
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -g")
   
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE}")
    set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")

    if (BASISU_SAN)
        message("Enabling SAN")
        
        set(SANITIZE_FLAGS "-fsanitize=address -fno-omit-frame-pointer -fsanitize=undefined -fno-sanitize=alignment")
        
        set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} ${SANITIZE_FLAGS}")
        set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} ${SANITIZE_FLAGS}")
    
        set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} ${SANITIZE_FLAGS}")
        set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} ${SANITIZE_FLAGS}")
    endif()

    # set(CMAKE_CXX_FLAGS -std=c++17)
    set(GCC_COMPILE_FLAGS "-fvisibility=hidden -fPIC -fno-strict-aliasing -D_LARGEFILE64_SOURCE=1 -D_FILE_OFFSET_BITS=64 -Wall -Wextra -Wno-misleading-indentation")
   
    if (NOT BASISU_BUILD_X64)
        set(GCC_COMPILE_FLAGS "${GCC_COMPILE_FLAGS} -m32")
    endif()

    if (EMSCRIPTEN)
        set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -s ALLOW_MEMORY_GROWTH=1 -DBASISU_SUPPORT_SSE=0")
        set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -s ALLOW_MEMORY_GROWTH=1 -DBASISU_SUPPORT_SSE=0")

        set(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} ${GCC_LINK_FLAGS}")
    elseif (BASISU_STATIC)
        if (BASISU_SSE)
            set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -DBASISU_SUPPORT_SSE=1 -msse4.1")
            set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DBASISU_SUPPORT_SSE=1 -msse4.1")
        else()
            set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -DBASISU_SUPPORT_SSE=0")
            set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DBASISU_SUPPORT_SSE=0")
        endif()
      
        set(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} ${GCC_LINK_FLAGS} -static-libgcc -static-libstdc++ -static")
    else()
        if (BASISU_SSE)
            set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -DBASISU_SUPPORT_SSE=1 -msse4.1")
            set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DBASISU_SUPPORT_SSE=1 -msse4.1")
        else()
            set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -DBASISU_SUPPORT_SSE=0")
            set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DBASISU_SUPPORT_SSE=0")
        endif()
      
        set(CMAKE_EXE_LINKER_FLAGS  "${CMAKE_EXE_LINKER_FLAGS} ${GCC_LINK_FLAGS} -Wl,-rpath .")
    endif()

    set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} ${GCC_COMPILE_FLAGS}")
    set(CMAKE_C_FLAGS_RELEASE  "${CMAKE_C_FLAGS_RELEASE} ${GCC_COMPILE_FLAGS}")
    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} ${GCC_COMPILE_FLAGS} -D_DEBUG")

    set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} ${GCC_COMPILE_FLAGS}")
    set(CMAKE_CXX_FLAGS_RELEASE  "${CMAKE_CXX_FLAGS_RELEASE} ${GCC_COMPILE_FLAGS}")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} ${GCC_COMPILE_FLAGS} -D_DEBUG")
elseif (BASISU_BUILD_WASM)
    # _WASI_EMULATED_PROCESS_CLOCKS/-lwasi-emulated-process-clocks is only for ZStd
    add_compile_definitions(_WASI_EMULATED_PROCESS_CLOCKS)
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -lwasi-emulated-process-clocks")

    set(CMAKE_C_FLAGS   "${CMAKE_C_FLAGS} -fno-strict-aliasing -fvisibility=hidden -Wall -Wextra -Wno-unknown-warning-option")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-strict-aliasing -fvisibility=hidden -Wall -Wextra -Wno-unknown-warning-option")

    set(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -g")
    set(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -g")

    set(CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE} -O2")
    set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -O2")
    
    # We need a few MB of stack - don't skip this or WASMTime will silently allow the stack to grow into the heap or static memory, causing corruption.
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--stack-first -Wl,-z,stack-size=8388608")
else()
    if (BASISU_SSE)
        set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -DBASISU_SUPPORT_SSE=1")
        set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DBASISU_SUPPORT_SSE=1")
    else()
        set(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -DBASISU_SUPPORT_SSE=0")
        set(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -DBASISU_SUPPORT_SSE=0")
    endif()
endif()

# Define the source files for the static library
set(ENCODER_LIB_SRC_LIST
    encoder/basisu_backend.cpp
    encoder/basisu_basis_file.cpp
    encoder/basisu_comp.cpp
    encoder/basisu_enc.cpp
    encoder/basisu_etc.cpp
    encoder/basisu_frontend.cpp
    encoder/basisu_gpu_texture.cpp
    encoder/basisu_pvrtc1_4.cpp
    encoder/basisu_resampler.cpp
    encoder/basisu_resample_filters.cpp
    encoder/basisu_ssim.cpp
    encoder/basisu_uastc_enc.cpp
    encoder/basisu_bc7enc.cpp
    encoder/jpgd.cpp
    encoder/basisu_kernels_sse.cpp
    encoder/basisu_opencl.cpp
    encoder/pvpngreader.cpp
    encoder/basisu_uastc_hdr_4x4_enc.cpp
    encoder/basisu_astc_hdr_6x6_enc.cpp
    encoder/basisu_astc_hdr_common.cpp
    encoder/basisu_astc_ldr_common.cpp
    encoder/basisu_astc_ldr_encode.cpp
    encoder/3rdparty/android_astc_decomp.cpp
    encoder/3rdparty/tinyexr.cpp
    transcoder/basisu_transcoder.cpp
    encoder/basisu_astc_hdr_6x6_enc.h
    encoder/basisu_astc_hdr_common.h
    encoder/basisu_backend.h
    encoder/basisu_basis_file.h
    encoder/basisu_bc7enc.h
    encoder/basisu_comp.h
    encoder/basisu_enc.h
    encoder/basisu_etc.h
    encoder/basisu_frontend.h
    encoder/basisu_gpu_texture.h
    encoder/basisu_kernels_declares.h
    encoder/basisu_kernels_imp.h
    encoder/basisu_math.h
    encoder/basisu_miniz.h
    encoder/basisu_ocl_kernels.h
    encoder/basisu_opencl.h
    encoder/basisu_pvrtc1_4.h
    encoder/basisu_resampler_filters.h
    encoder/basisu_resampler.h
    encoder/basisu_ssim.h
    encoder/basisu_uastc_enc.h
    encoder/basisu_uastc_hdr_4x4_enc.h
    encoder/basisu_astc_ldr_common.h
    encoder/basisu_astc_ldr_encode.h
    encoder/cppspmd_flow.h
    encoder/cppspmd_math_declares.h
    encoder/cppspmd_math.h
    encoder/cppspmd_sse.h
    encoder/cppspmd_type_aliases.h
    encoder/jpgd.h
    encoder/pvpngreader.h
    encoder/3rdparty/android_astc_decomp.h
    encoder/3rdparty/qoi.h
    encoder/3rdparty/tinyexr.h
    transcoder/basisu_astc_hdr_core.h
    transcoder/basisu_astc_helpers.h
    transcoder/basisu_containers_impl.h
    transcoder/basisu_containers.h
    transcoder/basisu_file_headers.h
    transcoder/basisu_transcoder_internal.h
    transcoder/basisu_transcoder_uastc.h
    transcoder/basisu_transcoder.h
    transcoder/basisu_idct.h
    transcoder/basisu.h
    zstd/zstd.h
)

if (BASISU_ZSTD)
    set(ENCODER_LIB_SRC_LIST ${ENCODER_LIB_SRC_LIST} zstd/zstd.c)
endif()

# Create the static library
add_library(basisu_encoder STATIC ${ENCODER_LIB_SRC_LIST})

# Create the basisu executable and link against the static library
add_executable(basisu basisu_tool.cpp)
target_link_libraries(basisu PRIVATE basisu_encoder)

# Create the new example executable and link against the static library
if(BASISU_EXAMPLES)
    add_executable(example example/example.cpp)
    target_link_libraries(example PRIVATE basisu_encoder)
    
    add_executable(example_capi example_capi/example_capi.c encoder/basisu_wasm_api.cpp encoder/basisu_wasm_transcoder_api.cpp)
    target_link_libraries(example_capi PRIVATE basisu_encoder)
    
    add_executable(example_transcoding example_transcoding/example_transcoding.cpp example_transcoding/utils.cpp zstd/zstddeclib.c transcoder/basisu_transcoder.cpp)
endif() 

if (BASISU_BUILD_WASM)
    # Add proper suffix
    set_target_properties(basisu PROPERTIES SUFFIX ".wasm")
    
    if(BASISU_EXAMPLES)
        set_target_properties(example PROPERTIES SUFFIX ".wasm")
        set_target_properties(example_capi PROPERTIES SUFFIX ".wasm")
        set_target_properties(example_transcoding PROPERTIES SUFFIX ".wasm")
    endif()

    if (BASISU_WASM_THREADING)

=== webgl/encoder/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(basisu_encoder_js)

# Toggle Zstd support for KTX2 (ON by default).
option(KTX2_ZSTANDARD "Enable KTX2 Zstandard support" TRUE)
message("KTX2_ZSTANDARD=${KTX2_ZSTANDARD}")

# Only for Emscripten builds.
if(EMSCRIPTEN)
  set(CMAKE_CXX_STANDARD 17)

  # ---------- Pick config once (single-config generators) ----------
  # Supports: Release (default), Debug, SAN
  if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release")
  endif()
  string(TOUPPER "${CMAKE_BUILD_TYPE}" BUILD_MODE)

  # Per-config compile/link flags
  set(CONFIG_CFLAGS "")
  set(CONFIG_DEFS  "")
  set(CONFIG_LINK  "")

  if(BUILD_MODE STREQUAL "RELEASE")
    set(CONFIG_CFLAGS "-O3")
    set(CONFIG_DEFS   "NDEBUG")
    set(CONFIG_LINK   "-O3 -s ASSERTIONS=0")
  elseif(BUILD_MODE STREQUAL "DEBUG")
    set(CONFIG_CFLAGS "-g -O0")
    set(CONFIG_DEFS   "DEBUG")
    set(CONFIG_LINK   "-g -s ASSERTIONS=2")
  elseif(BUILD_MODE STREQUAL "SAN")
    set(CONFIG_CFLAGS "-g -O1 -fsanitize=undefined -fsanitize=address")
    set(CONFIG_DEFS   "DEBUG")
    set(CONFIG_LINK   "-g -s ASSERTIONS=2 -fsanitize=undefined -fsanitize=address")
  else()
    message(WARNING "Unknown CMAKE_BUILD_TYPE='${CMAKE_BUILD_TYPE}', defaulting to Release-like flags.")
    set(CONFIG_CFLAGS "-O3")
    set(CONFIG_DEFS   "NDEBUG")
    set(CONFIG_LINK   "-O3 -s ASSERTIONS=0")
  endif()

  # ---------- Sources (shared) ----------
  set(SRC_LIST
    ../transcoder/basis_wrappers.cpp
    ../../transcoder/basisu_transcoder.cpp
    ../../encoder/basisu_backend.cpp
    ../../encoder/basisu_basis_file.cpp
    ../../encoder/basisu_comp.cpp
    ../../encoder/basisu_enc.cpp
    ../../encoder/basisu_etc.cpp
    ../../encoder/basisu_frontend.cpp
    ../../encoder/basisu_gpu_texture.cpp
    ../../encoder/basisu_pvrtc1_4.cpp
    ../../encoder/basisu_resampler.cpp
    ../../encoder/basisu_resample_filters.cpp
    ../../encoder/basisu_ssim.cpp
    ../../encoder/basisu_uastc_enc.cpp
    ../../encoder/basisu_bc7enc.cpp
    ../../encoder/basisu_kernels_sse.cpp
    ../../encoder/basisu_opencl.cpp
    ../../encoder/pvpngreader.cpp
    ../../encoder/jpgd.cpp
    ../../encoder/3rdparty/android_astc_decomp.cpp
    ../../encoder/basisu_uastc_hdr_4x4_enc.cpp
    ../../encoder/basisu_astc_hdr_6x6_enc.cpp
    ../../encoder/basisu_astc_hdr_common.cpp
    ../../encoder/basisu_astc_ldr_common.cpp
    ../../encoder/basisu_astc_ldr_encode.cpp
    ../../encoder/3rdparty/tinyexr.cpp
  )
  if(KTX2_ZSTANDARD)
    list(APPEND SRC_LIST ../../zstd/zstd.c)
    set(ZSTD_DEFINITION BASISD_SUPPORT_KTX2_ZSTD=1)
  else()
    set(ZSTD_DEFINITION BASISD_SUPPORT_KTX2_ZSTD=0)
  endif()

  # Common preprocessor defines (same as your original)
  set(COMMON_DEFS
    BASISD_SUPPORT_UASTC=1
    BASISD_SUPPORT_BC7=1
    BASISD_SUPPORT_ATC=0
    BASISD_SUPPORT_ASTC_HIGHER_OPAQUE_QUALITY=0
    BASISD_SUPPORT_PVRTC2=0
    BASISD_SUPPORT_FXT1=0
    BASISD_SUPPORT_ETC2_EAC_RG11=0
    BASISU_SUPPORT_ENCODING=1
    BASISU_SUPPORT_SSE=0
    BASISD_SUPPORT_XUASTC=1
    ${ZSTD_DEFINITION}
  )

  # Base link flags 
  set(LINK_BASE "--bind -s ALLOW_MEMORY_GROWTH=1 -s INITIAL_MEMORY=536870912 -s STACK_SIZE=2097152 -s MODULARIZE=1 -s EXPORT_NAME=BASIS -s EXPORTED_RUNTIME_METHODS=['HEAP8']")
  set(LINK_THREADS "-s USE_PTHREADS=1 -s PTHREAD_POOL_SIZE=18 -s ENVIRONMENT=web,worker")
  set(LINK_WASM64  "-s MEMORY64=1 -sWASM_BIGINT=1 --profiling-funcs")

  # Helper to avoid repetition
  function(add_encoder target out_name use_threads use_wasm64)
    add_executable(${target} ${SRC_LIST})
    set_target_properties(${target} PROPERTIES OUTPUT_NAME "${out_name}" SUFFIX ".js")
    target_include_directories(${target} PRIVATE ../../transcoder)

    # Compile defs and options
    target_compile_definitions(${target} PRIVATE ${COMMON_DEFS} ${CONFIG_DEFS})
    target_compile_options(${target} PRIVATE -fno-strict-aliasing ${CONFIG_CFLAGS})

    if(${use_threads})
      target_compile_options(${target} PRIVATE -matomics -mbulk-memory)
      target_compile_definitions(${target} PRIVATE WASM_THREADS_ENABLED=1)
    endif()
	
    if(${use_wasm64})
      target_compile_options(${target} PRIVATE -s MEMORY64=1)
    endif()

    # Link flags (no generator expressions)
    set(_lf "${LINK_BASE} ${CONFIG_LINK}")
	
    if(${use_threads})
      set(_lf "${_lf} ${LINK_THREADS}")
    endif()
	
    if(${use_wasm64})
      set(_lf "${_lf} ${LINK_WASM64} -s INITIAL_MEMORY=1073741824 -s MAXIMUM_MEMORY=12884901888")
    endif()
	
    set_target_properties(${target} PROPERTIES LINK_FLAGS "${_lf}")
  endfunction()

  # The three outputs (names unchanged)
  add_encoder(basis_encoder.js                 "basis_encoder"                OFF OFF) # wasm32
  add_encoder(basis_encoder_threads.js         "basis_encoder_threads"        ON  OFF) # wasm32 + threads
  add_encoder(basis_encoder_threads_wasm64.js  "basis_encoder_threads_wasm64" ON  ON ) # wasm64 + threads
endif()

=== webgl/transcoder/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(basisu_transcoder_js)

# KTX2 support (and Zstandard) in the transcoder is purely optional. Use "cmake -DKTX2=FALSE" to completely disable KTX2 support (which also disables Zstandard).
# If this is FALSE you'll only be able to transcode .basis files.
option(KTX2 "KTX2" TRUE)

# If KTX2 is enabled, Zstandard is needed to support decompressing supercompressed UASTC files.
# If you know you'll never be transcoding KTX2 files using this feature you can set KTX2_ZSTANDARD to 0.
option(KTX2_ZSTANDARD "KTX2_ZSTANDARD" TRUE)

message("KTX2=${KTX2}")
message("KTX2_ZSTANDARD=${KTX2_ZSTANDARD}")

if (EMSCRIPTEN)
  set(CMAKE_CXX_STANDARD 17)

  set(SRC_LIST
  	../../transcoder/basisu_transcoder.cpp
	basis_wrappers.cpp
  )

  if (KTX2)
	set(KTX2_DEFINITION BASISD_SUPPORT_KTX2=1)
  else()
  	set(KTX2_DEFINITION BASISD_SUPPORT_KTX2=0)
  endif()

  if (KTX2_ZSTANDARD)
 	set(SRC_LIST ${SRC_LIST}
		../../zstd/zstddeclib.c
	)
	set(ZSTD_DEFINITION BASISD_SUPPORT_KTX2_ZSTD=1)
  else()
  	set(ZSTD_DEFINITION BASISD_SUPPORT_KTX2_ZSTD=0)
  endif()

#  message("KTX2_DEFINITION=${KTX2_DEFINITION})
#  message("ZSTD_DEFINITION=${ZSTD_DEFINITION})

  add_executable(basis_transcoder.js ${SRC_LIST})

  target_compile_definitions(basis_transcoder.js PRIVATE NDEBUG
  	BASISD_SUPPORT_UASTC_HDR=1
	BASISD_SUPPORT_UASTC=1
	BASISD_SUPPORT_BC7=1
	BASISD_SUPPORT_ATC=0
	BASISD_SUPPORT_ASTC_HIGHER_OPAQUE_QUALITY=0
	BASISD_SUPPORT_PVRTC2=0
	BASISD_SUPPORT_FXT1=0
	BASISD_SUPPORT_ETC2_EAC_RG11=0
	BASISU_SUPPORT_ENCODING=0
	BASISD_ENABLE_DEBUG_FLAGS=1
	${KTX2_DEFINITION}
	${ZSTD_DEFINITION}
  )

  target_compile_options(basis_transcoder.js PRIVATE -O3 -fno-strict-aliasing)
  #target_compile_options(basis_transcoder.js PRIVATE -O0 -g -fno-strict-aliasing)

  target_include_directories(basis_transcoder.js PRIVATE ../../transcoder)

  set_target_properties(basis_transcoder.js PROPERTIES
      OUTPUT_NAME "basis_transcoder"
      SUFFIX ".js"
      LINK_FLAGS "--bind -s ALLOW_MEMORY_GROWTH=1 -O3 -s MALLOC=emmalloc -s MODULARIZE=1 -s EXPORT_NAME=BASIS -s ASSERTIONS=0 -s EXPORTED_RUNTIME_METHODS=['HEAP8']")
endif()

## basis-universal 1.60

=== debian/changelog ===
basis-universal (1.60-1) unstable; urgency=low

  * Initial release.

 -- Caoimhe Chaos <caoimhechaos@protonmail.com>  Sat, 15 Mar 2025 22:26:17 +0100

=== debian/control ===
Source: basis-universal
Section: libs
Priority: optional
Maintainer: Caoimhe Chaos <caoimhechaos@protonmail.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 emscripten,
 ocl-icd-libopencl1,
 ocl-icd-opencl-dev
Standards-Version: 4.7.2
Homepage: https://github.com/BinomialLLC/basis_universal
Vcs-Browser: https://github.com/BinomialLLC/basis_universal
Vcs-Git: https://github.com/BinomialLLC/basis_universal.git

Package: libbasis-universal-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ocl-icd-opencl-dev,
 ${misc:Depends},
Description:  Basis Universal GPU Texture Codec (headers and static library).
 Basis Universal is an open source supercompressed LDR/HDR GPU compressed
 texture interchange system from Binomial LLC that supports two intermediate
 file formats: the .KTX2 open standard from the Khronos Group, and our own
 ".basis" file format. These file formats support rapid transcoding to
 virtually any compressed GPU texture format released in the past ~25 years.
 .
 Our overall goal with this project is to simplify the encoding and efficient
 distribution of portable LDR and HDR GPU texture, image, and short texture
 video content in a way that is compatible with any GPU or rendering/graphics
 API.
 .
 The system supports five modes: ETC1S, UASTC LDR 4x4, UASTC HDR 4x4,
 UASTC HDR 6x6 (with or without RDO), or UASTC HDR 6x6 Intermediate
 ("GPU Photo"). The C/C++ encoder and transcoder libaries can be compiled to
 native code or WebAssembly, and all encoder/transcoder features can be
 accessed from Javascript via a C++ wrapper library which optionally
 supports WASM multithreading for fast encoding in the browser.

Package: libbasis-universal-bin
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
Description:  Basis Universal GPU Texture Codec (tools).
 Basis Universal is an open source supercompressed LDR/HDR GPU compressed
 texture interchange system from Binomial LLC that supports two intermediate
 file formats: the .KTX2 open standard from the Khronos Group, and our own
 ".basis" file format. These file formats support rapid transcoding to
 virtually any compressed GPU texture format released in the past ~25 years.
 .
 Our overall goal with this project is to simplify the encoding and efficient
 distribution of portable LDR and HDR GPU texture, image, and short texture
 video content in a way that is compatible with any GPU or rendering/graphics
 API.
 .
 The system supports five modes: ETC1S, UASTC LDR 4x4, UASTC HDR 4x4,
 UASTC HDR 6x6 (with or without RDO), or UASTC HDR 6x6 Intermediate
 ("GPU Photo"). The C/C++ encoder and transcoder libaries can be compiled to
 native code or WebAssembly, and all encoder/transcoder features can be
 accessed from Javascript via a C++ wrapper library which optionally
 supports WASM multithreading for fast encoding in the browser.

Package: libbasis-universal-doc
Architecture: all
Description: Basis Universal GPU Texture Codec library (Documentation).
 Basis Universal is an open source supercompressed LDR/HDR GPU compressed
 texture interchange system from Binomial LLC that supports two intermediate
 file formats: the .KTX2 open standard from the Khronos Group, and our own
 ".basis" file format. These file formats support rapid transcoding to
 virtually any compressed GPU texture format released in the past ~25 years.
 .
 Our overall goal with this project is to simplify the encoding and efficient
 distribution of portable LDR and HDR GPU texture, image, and short texture
 video content in a way that is compatible with any GPU or rendering/graphics
 API.
 .
 The system supports five modes: ETC1S, UASTC LDR 4x4, UASTC HDR 4x4,
 UASTC HDR 6x6 (with or without RDO), or UASTC HDR 6x6 Intermediate
 ("GPU Photo"). The C/C++ encoder and transcoder libaries can be compiled to
 native code or WebAssembly, and all encoder/transcoder features can be
 accessed from Javascript via a C++ wrapper library which optionally
 supports WASM multithreading for fast encoding in the browser.

=== debian/rules ===
#!/usr/bin/make -f

# See debhelper(7) (uncomment to enable).
# Output every command that modifies files on the build system.
#export DH_VERBOSE = 1


# See FEATURE AREAS in dpkg-buildflags(1).
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# See ENVIRONMENT in dpkg-buildflags(1).
# Package maintainers to append CFLAGS.
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# Package maintainers to append LDFLAGS.
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@ --buildsystem=cmake


# dh_make generated override targets.
# This is an example for Cmake (see <https://bugs.debian.org/641051>).
override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	-DOPENCL=ON

=== debian/watch ===
# Example watch control file for uscan.
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# See uscan(1) for format.

# Compulsory line, this is a version 4 file.
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%" \
    https://github.com/BinomialLLC/basis_universal/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@

## basis-universal 2.0.2

=== debian/changelog ===
basis-universal (2.0.2-3) unstable; urgency=medium

  * Depend and build-depend on sse4.1-support [amd64 i386 x32]
    Closes: #1128607

 -- Russell Coker <russell@coker.com.au>  Sun, 22 Feb 2026 11:28:28 +1100

basis-universal (2.0.2-2) unstable; urgency=medium

  * Only use SSE on amd64, i386, and x32 Closes: #1128062

 -- Russell Coker <russell@coker.com.au>  Tue, 17 Feb 2026 21:15:16 +1100

basis-universal (2.0.2-1) unstable; urgency=medium

  * 2.0.2 upstream release
  * Fixed the debian/copyright file

 -- Russell Coker <russell@coker.com.au>  Sun, 15 Feb 2026 14:14:29 +1100

basis-universal (1.60-2) unstable; urgency=medium

  * Fixed the section

 -- Russell Coker <russell@coker.com.au>  Tue, 14 Oct 2025 23:50:23 +1100

basis-universal (1.60-1) unstable; urgency=medium

  * Initial release. (Closes: #1038205)

 -- Russell Coker <russell@coker.com.au>  Thu, 25 Sep 2025 16:27:17 +1000

=== debian/control ===
Source: basis-universal
Section: devel
Priority: optional
Maintainer: Russell Coker <russell@coker.com.au>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 sse4.1-support [amd64 i386 x32]
Standards-Version: 4.7.2
Homepage: https://github.com/BinomialLLC/basis_universal
#Vcs-Browser: https://salsa.debian.org/debian/basis-universal
#Vcs-Git: https://salsa.debian.org/debian/basis-universal.git

Package: gpu-basis-universal
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 sse4.1-support [amd64 i386 x32]
Description: GPU compressed texture encoding system
 Basis Universal is an open source supercompressed LDR/HDR GPU compressed
 texture interchange system from Binomial LLC that supports two intermediate
 file formats: the .KTX2 open standard from the Khronos Group, and the
 ".basis" file format. These file formats support rapid transcoding to
 virtually any compressed GPU texture format released in the past ~25 years.
 .
 Used for compiling data files for games.

=== debian/rules ===
--- 
+++ 
@@ -14,14 +14,29 @@
 # Package maintainers to append LDFLAGS.
 #export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
+DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
+ifeq ($(DEB_BUILD_ARCH),amd64)
+    SSE=-DBASISU_SSE=1
+endif
+ifeq ($(DEB_BUILD_ARCH),i386)
+    SSE=-DBASISU_SSE=1
+endif
+ifeq ($(DEB_BUILD_ARCH),x32)
+    SSE=-DBASISU_SSE=1
+endif
 
 %:
-	dh $@ --buildsystem=cmake
+	dh $@
 
+override_dh_auto_clean:
+	dh_auto_clean
+	rm -f bin/*
+
+override_dh_auto_configure:
+	dh_auto_configure -- $(SSE)
 
 # dh_make generated override targets.
 # This is an example for Cmake (see <https://bugs.debian.org/641051>).
-override_dh_auto_configure:
-	dh_auto_configure -- \
-	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
-	-DOPENCL=ON
+#override_dh_auto_configure:
+#	dh_auto_configure -- \
+#	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)
